/*
 * GPIO definitions for px27x-based B4 platform
 *
 * Copyright 2007 STC Metrotek, Saint-Petersburg, Russia
 *
 * Author: Pavel Kurochkin<pk@metrotek.spb.ru>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 */
#ifndef __ASM_ARCH_B4_H
#define __ASM_ARCH_B4_H  1

#define GPIO_IN                 0x000
#define GPIO_OUT                0x080
#define GPIO_ALT_FN_1_IN        0x100
#define GPIO_ALT_FN_1_OUT       0x180
#define GPIO_ALT_FN_2_IN        0x200
#define GPIO_ALT_FN_2_OUT       0x280
#define GPIO_ALT_FN_3_IN        0x300
#define GPIO_ALT_FN_3_OUT       0x380

#define B4_GPIO_CF_IRQ      (94)   /* CF IRQ */
#define B4_GPIO_CF_DETECT   (101)  /* CF Card Detect */
#define B4_GPIO_CF_PWR      (103)  /* CF Power */
#define B4_GPIO_CF_RESET    (99)   /* CF Reset */
#define B4_GPIO_CF_STSCHG   (95)   /* CF Status Change */
#define B4_GPIO_CF_PSKTSEL  (104)  /* CF PSKTSEL */


/*
 * B4 Interrupts
 */
#define B4_IRQ_GPIO_CF_DETECT   IRQ_GPIO(B4_GPIO_CF_DETECT)
#define B4_IRQ_GPIO_CF_IRQ      IRQ_GPIO(B4_GPIO_CF_IRQ)
#define B4_IRQ_GPIO_CF_STSCHG   IRQ_GPIO(B4_GPIO_CF_STSCHG)

/*
 * FF
 */
#define B4_GPIO_FF_TXD          (16 | GPIO_ALT_FN_3_OUT)
#define B4_GPIO_FF_RTS          (27 | GPIO_ALT_FN_3_OUT)
#define B4_GPIO_FF_RXD          (34 | GPIO_ALT_FN_1_IN)
#define B4_GPIO_FF_CTS          (35 | GPIO_ALT_FN_1_IN)
#define B4_GPIO_FF_DCD          (36 | GPIO_ALT_FN_1_IN)
#define B4_GPIO_FF_DSR          (37 | GPIO_ALT_FN_1_IN)
#define B4_GPIO_FF_RI           (38 | GPIO_ALT_FN_1_IN)
#define B4_GPIO_FF_DTR          (40 | GPIO_ALT_FN_2_OUT)


#endif /* __ASM_ARCH_B4_H  */

