/*
 *
 * Definitions for HTC Himalaya
 *
 * Copyright 2004 Xanadux.org
 *
 * Use consistent with the GNU GPL is permitted,
 * provided that this copyright notice is
 * preserved in its entirety in all copies and derived works.
 *
 * Author: w4xy@xanadux.org
 *
 */

/* Names based on h1900-gpio.h */

#ifndef _HIMALAYA_GPIO_H_
#define _HIMALAYA_GPIO_H_

#define HIMALAYA_ASIC3_SD_PHYS  0x0D000000
#define HIMALAYA_ASIC3_PHYS     0x0D800000

#define GPIO_NR_HIMALAYA_POWER_BUTTON_N	(0)   /* Also known as the "off button" - INPUT */
#define GPIO_NR_HIMALAYA_WARM_RST_N	(1)   /* external circuit to differentiate warm/cold resets - INPUT*/

#define GPIO_NR_HIMALAYA_USB_DETECT_N	(3)
#define GPIO_NR_HIMALAYA_RS232_IN	(4)
#define GPIO_NR_HIMALAYA_PEN		(5)
#define GPIO_NR_HIMALAYA_BUTTON		(7)
#define GPIO_NR_HIMALAYA_ASIC3		(8)
#define GPIO_NR_HIMALAYA_UART_POWER     (21)
#define GPIO_NR_HIMALAYA_USB_PULLUP_N	(60)
#define GPIO_NR_HIMALAYA_CHARGER_EN	(63)

#define IRQ_NR_HIMALAYA_USB_DETECT_N	IRQ_GPIO(GPIO_NR_HIMALAYA_USB_DETECT_N)
#define IRQ_NR_HIMALAYA_RS232_IN	IRQ_GPIO(GPIO_NR_HIMALAYA_RS232_IN)
#define IRQ_NR_HIMALAYA_PEN		IRQ_GPIO(GPIO_NR_HIMALAYA_PEN)
#define IRQ_NR_HIMALAYA_BUTTON		IRQ_GPIO(GPIO_NR_HIMALAYA_BUTTON)
#define IRQ_NR_HIMALAYA_ASIC3		IRQ_GPIO(GPIO_NR_HIMALAYA_ASIC3)

/*
#define GPIO_NR_HIMALAYA_COM_DCD	
#define GPIO_NR_HIMALAYA_AC_IN_N	
#define GPIO_NR_HIMALAYA_BATTERY_DOOR_N	
#define GPIO_NR_HIMALAYA_USB_DETECT2_N	
#define GPIO_NR_HIMALAYA_APP_BUTTON0_N	
#define GPIO_NR_HIMALAYA_ASIC_IRQ_1_N	
#define GPIO_NR_HIMALAYA_SD_IRQ_N	
#define GPIO_NR_HIMALAYA_MBAT_IN	
#define GPIO_NR_HIMALAYA_ASIC3_IRQ	
#define GPIO_NR_HIMALAYA_ASIC_IRQ_2_N	
#define GPIO_NR_HIMALAYA_USB_DETECT_N	
#define GPIO_NR_HIMALAYA_RECORD_BUTTON_N	
#define GPIO_NR_HIMALAYA_LCD_PWM	
#define GPIO_NR_HIMALAYA_SOFT_RESET_N	
#define GPIO_NR_HIMALAYA_UP_BUTTON_N	
#define GPIO_NR_HIMALAYA_APP_BUTTON2_N	
#define GPIO_NR_HIMALAYA_ACTION_BUTTON_	
#define GPIO_NR_HIMALAYA_SPI_CLK	
#define GPIO_NR_HIMALAYA_SPI_CS_N	
#define GPIO_NR_HIMALAYA_SPI_TXD	
#define GPIO_NR_HIMALAYA_SPI_RXD	
#define GPIO_NR_HIMALAYA_PEN_IRQ_N	

#define GPIO_NR_HIMALAYA_AC97_BITCLK	
#define GPIO_NR_HIMALAYA_AC97_SDATA_IN	
#define GPIO_NR_HIMALAYA_AC97_SDATA_OUT	
#define GPIO_NR_HIMALAYA_AC97_SYNC	

#define GPIO_NR_HIMALAYA_SYS_CLK	

#define GPIO_NR_HIMALAYA_LCD_SOMETHING	
#define GPIO_NR_HIMALAYA_FFUART_CTS_N      
#define GPIO_NR_HIMALAYA_FL_PWR_EN         
#define GPIO_NR_HIMALAYA_FLASH_VPEN        
#define GPIO_NR_HIMALAYA_LCD_PCI		
#define GPIO_NR_HIMALAYA_FFUART_TXD        
#define GPIO_NR_HIMALAYA_FW_LOW_N          
#define GPIO_NR_HIMALAYA_FFUART_RTS_N      

#define GPIO_NR_HIMALAYA_CHARGER_EN        
#define GPIO_NR_HIMALAYA_DOWN_BUTTON_N     
#define GPIO_NR_HIMALAYA_LEFT_BUTTON_N     
#define GPIO_NR_HIMALAYA_RIGHT_BUTTON_N    

#define GPIO_NR_HIMALAYA_IR_RXD            
#define GPIO_NR_HIMALAYA_IR_TXD            

#define GPIO_NR_HIMALAYA_VGL_EN            

#define GPIO_NR_HIMALAYA_LCD_DVDD_EN       
#define GPIO_NR_HIMALAYA_AUX_PWR_EN        
#define GPIO_NR_HIMALAYA_SPEAKER_EN        
#define GPIO_NR_HIMALAYA_HEADPHONE_EN      
#define GPIO_NR_HIMALAYA_ASIC3_RESET_N     
#define GPIO_NR_HIMALAYA_FLASH_BUSY_N      
#define GPIO_NR_HIMALAYA_KB_DETECT_N       
#define GPIO_NR_HIMALAYA_HEADPHONE_IN_N    
*/

#endif /* _HIMALAYA_GPIO_H_ */
